/*
 * The Clear BSD License
 * Copyright 2017-2018 NXP
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted (subject to the limitations in the disclaimer below) provided
 *  that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 *
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_common.h"
#include "fsl_gpio.h"
#include "fsl_spi.h"
#include "fsl_i2c.h"
#include "fsl_reset.h"
#include "fsl_usart.h"
#include "fsl_clock.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitBUTTONsPeripheral functional group */
/* Alias for GPIO peripheral */
#define BOARD_SW_GPIO GPIO

/* Definitions for BOARD_InitLEDsPeripheral functional group */
/* Alias for GPIO peripheral */
#define BOARD_LEDS_GPIO GPIO

/* Definitions for BOARD_InitPMod_BRIDGEPeripheral functional group */
/* Alias for GPIO peripheral */
#define BOARD_BRIDGE_GPIO_GPIO GPIO
/* BOARD_InitPMod_BRIDGEPeripheral defines for FLEXCOMM3 */
/* Definition of peripheral ID */
#define BOARD_PMOD_SPI_PERIPHERAL ((SPI_Type *)FLEXCOMM3)
/* Definition of the clock source frequency */
#define BOARD_PMOD_SPI_CLOCK_SOURCE CLOCK_GetFreq(kCLOCK_Flexcomm3)
/* BOARD_InitPMod_BRIDGEPeripheral defines for FLEXCOMM1 */
/* Definition of peripheral ID */
#define BOARD_PMOD_I2C_PERIPHERAL ((I2C_Type *)FLEXCOMM1)
/* Definition of the clock source frequency */
#define BOARD_PMOD_I2C_CLOCK_SOURCE CLOCK_GetFreq(kCLOCK_Flexcomm1)

/* Definitions for BOARD_InitACCELPeripheral functional group */
/* BOARD_InitACCELPeripheral defines for FLEXCOMM2 */
/* Definition of peripheral ID */
#define BOARD_ACCEL_PERIPHERAL ((I2C_Type *)FLEXCOMM2)
/* Definition of the clock source frequency */
#define BOARD_ACCEL_CLOCK_SOURCE CLOCK_GetFreq(kCLOCK_Flexcomm2)
/* Alias for GPIO peripheral */
#define BOARD_ACCL_INTR_GPIO GPIO

/* Definitions for BOARD_InitQSPI_FLASHPeripheral functional group */
/* Alias for GPIO peripheral */
#define BOARD_SPIFI_RSTN_GPIO GPIO

/* Definitions for BOARD_InitDEBUG_UARTPeripheral functional group */
/* Definition of peripheral ID */
#define BOARD_DEBUG_UART_PERIPHERAL ((USART_Type *)FLEXCOMM0)
/* Definition of the clock source frequency */
#define BOARD_DEBUG_UART_CLOCK_SOURCE CLOCK_GetFreq(kCLOCK_Flexcomm0)

/* Definitions for BOARD_InitENETPeripheral functional group */
/* Alias for GPIO peripheral */
#define BOARD_ENET_PHY_RSTN_GPIO GPIO

/* Definitions for BOARD_InitI2SPeripheral functional group */
/* BOARD_InitI2SPeripheral defines for FLEXCOMM2 */
/* Definition of peripheral ID */
#define BOARD_I2S_I2C_PERIPHERAL ((I2C_Type *)FLEXCOMM2)
/* Definition of the clock source frequency */
#define BOARD_I2S_I2C_CLOCK_SOURCE CLOCK_GetFreq(kCLOCK_Flexcomm2)

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const spi_master_config_t BOARD_PMOD_SPI_config;
extern const i2c_master_config_t BOARD_PMOD_I2C_config;
extern const i2c_master_config_t BOARD_ACCEL_config;
extern const usart_config_t BOARD_DEBUG_UART_config;
extern const i2c_master_config_t BOARD_I2S_I2C_config;

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void);
void BOARD_InitBUTTONsPeripheral(void);
void BOARD_InitLEDsPeripheral(void);
void BOARD_InitPMod_BRIDGEPeripheral(void);
void BOARD_InitACCELPeripheral(void);
void BOARD_InitQSPI_FLASHPeripheral(void);
void BOARD_InitDEBUG_UARTPeripheral(void);
void BOARD_InitENETPeripheral(void);
void BOARD_InitI2SPeripheral(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
